import javax.sound.sampled.*;
import java.io.*;

/** Abstraktni trida SoundBuffer - vystup zvuku.
    Prijima na vstupu zvuky, ktere jsou skladany za sebe a posilany dle konkretni implementujici tridy
    na cilove zarizdeni (zvukova karta, soubor ...)*/
public abstract class SoundBuffer {

 /** Vrati AudioInputStream pro dany soubor f */
 public static AudioInputStream audioFromFile(File f) {
  try {
   AudioInputStream audioIn=AudioSystem.getAudioInputStream(f);
   return audioIn;
  } catch (Exception e) {
   return null;
  }
 }

 /** Prida msec milisekund ticha na vystupni stream */
 public abstract boolean addSilence(int msec);

 /** Prida obsah AudioInputStreamu na vystupni stream */
 public abstract boolean addStream(AudioInputStream in) throws IOException;

 /** Prida obsah souboru na vystupni stream */
 public boolean addFile(File f) throws IOException{
  return addStream(audioFromFile(f));
 }

 /** Pocka na vyprazdneni sound bufferu (az se jeho obsah posle tam kam ma - zvukovka/soubor...)*/
 public abstract void waitStop();

 /** Pocka na vyprazdneni a zavre buffer */
 public abstract void close() throws SpeechException;
}