import javax.sound.sampled.*;
import java.io.*;

/** implementace SoundBufffer, ktera data posila na zvukovou kartu */
public class SoundBufferCard extends SoundBuffer {

 private AudioFormat audioF;
 private SourceDataLine line;
 private float bps;//bytu/sec

 /** Konstruktor, vytvori buffer s vystupem do zvukove karty a danym AudioFormatem */
 public SoundBufferCard(AudioFormat aud) throws LineUnavailableException{
  audioF=aud;
  DataLine.Info info=new DataLine.Info(SourceDataLine.class,audioF);
  line=(SourceDataLine)AudioSystem.getLine(info);
  line.open(audioF);
  line.start();
  bps=audioF.getChannels()*audioF.getFrameRate()*audioF.getFrameSize();
 }

 /** Prida msec milisekund ticha na vystupni stream */
 public boolean addSilence(int msec) {
  int tsize=(int)(bps*msec)/1000;
  byte[] buf = new byte[tsize];
  int nWrite=line.write(buf,0,tsize);
  if (tsize!=nWrite) return false;
  return true; 
 }

 /** Prida obsah AudioInputStreamu na vystupni stream */
 public boolean addStream(AudioInputStream in) throws IOException{
  int nRead = 0;
  byte[] buf = new byte[4096];
  while (nRead!=-1) {
   nRead=in.read(buf,0,buf.length);
   if (nRead>=0) {
    int nWrite=line.write(buf,0,nRead);
    if (nRead!=nWrite) return false;
   }
  }
  return true;
 }

 /** Pocka na vyprazdneni sound bufferu (az se jeho obsah posle tam kam ma - zvukovka/soubor...)*/
 public void waitStop() {
  line.drain();
 }

 /** Pocka na vyprazdneni a zavre buffer */
 public void close() {
  waitStop();
  line.close();
 }
}