import java.io.*;
import java.util.*;
import javax.sound.sampled.*;

/** Testovaci program pro tridu Speech - pronese vetu */
public class say {

 private static final String wordlistFile="word/wlist-opt.txt";
 private static final String wordlistEncoding="iso-8859-2";

 /** vypise napovedu ke commandline */
 private static void usage() {
  System.out.println("Syntaxe:   java say [parametry] <veta>");
  System.out.println("           veta je jakakoliv veta v ceskem jazyce");
  System.out.println("Parametry: /s [soubor.wav] : ulozi prednes do soubor.wav");
  System.out.println("Priklad:   java say Ahoj svete");
 }

 /** Predrika vsechny argumenty co dostane na command line */
 public static void main(String[] args) {
  BenchTimer t=new BenchTimer();
  long time;
  int paramoffset=0;
  String saveas=null;
  try {
   Properties p=new Properties();
   try {
    p.load(new FileInputStream(new File("speech.properties")));
   } catch (Exception e) {
    System.err.println("Nelze nahrat soubor s nastavenim (speech.properties)");
    System.err.println("Budou pouzity standardni hodnoty");
   }
   if (args.length<1) {
    usage();
    return;
   }
   System.out.println("Kecal v0.9");
   if (args[0].equals("/s")) {
    if (args.length<3) {
     usage();
     return;
    }
    saveas=args[1];
    paramoffset=2;
   }
   System.out.print("Nahravam zvuky...");
   t.start();
   Speech sp=new Speech(p.getProperty("sounddir","sound"));
   t.stopPrint();
   System.out.print("Nahravam slovnik...");
   t.start();
   try {
    sp.loadVocabulary(p.getProperty("wordlist",wordlistFile),p.getProperty("wordlist.encoding",wordlistEncoding));
    t.stopPrint();
   } catch (Exception e) {
    System.out.println("chyba");
    System.out.println("Slovnik "+wordlistFile+" nelze nahrat!");
   }
   int i;
   System.out.print("Mluvim...");
   t.start();
   String sentence="";
   for (i=paramoffset;i<args.length;i++) {
    if (i>paramoffset) sentence+=" "; //mezera mezi slovy/vetou
    sentence+=args[i];
   }
   if (saveas==null) {
    sp.say(sentence);
   } else {
    sp.sayToFile(sentence,saveas);
   }
   t.stopPrint();
  } catch (Exception e) {
   e.printStackTrace();
  }
 //VM se tady sekne. Nevim proc, ale chce ji to asi trochu pomoct :o)
  System.exit(0);
 }
}
